﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using ThinkGeo.MapSuite.Core;

namespace DatumTransformTest
{
    class Program
    {
        static void Main(string[] args)
        {

            /// Point from Timbalai RSO shape file for Rx001
            PointShape point = new PointShape(500000, 500000);
            Feature pointFeature = new Feature(point);

            // Convert WGS
            ManagedProj4Projection wgsProj = new ManagedProj4Projection();
            wgsProj.ExternalProjectionParametersString = ManagedProj4Projection.GetWgs84ParametersString();
            wgsProj.InternalProjectionParametersString = ManagedProj4Projection.GetEpsgParametersString(29873);

            wgsProj.Open();
            Feature wgsFeature = wgsProj.ConvertToExternalProjection(pointFeature);
            PointShape wgsPoint = new PointShape(wgsFeature.GetWellKnownText());

            PointShape expectedPoint = new PointShape(114.18930293, 4.51828409);

            // Compute the delta X,Y
            double deltaX = expectedPoint.X - wgsPoint.X;
            double deltaY = expectedPoint.Y - wgsPoint.Y;

            // Write out the data
            Console.WriteLine(string.Format("Original X/Y: {0}", point.ToString()));
            Console.WriteLine(string.Format("WGS84 Lat/Long: {0}", wgsPoint.ToString()));
            Console.WriteLine(string.Format("Expected Lat/Long: {0}", wgsPoint.ToString()));
            Console.WriteLine(string.Format("Delta X:{0}, Delta Y: {1}", deltaX, deltaY));

        }

    }
}
